DEFINT A-Z
DECLARE FUNCTION Initalise (Xr, Yr, Deph, SetInterFace, LoadText$)
DECLARE SUB End.Gui ()
DECLARE SUB Run.Gui ()
DECLARE SUB ReFreshScreen (ToWindow)
DECLARE SUB RefreshWindows (FromWindow, ToWindow)
DECLARE SUB Refresh.Windows ()
DECLARE SUB SwichPage ()
DECLARE FUNCTION Draw.Object (Object, Specification)
DECLARE SUB End.DrawObject ()
DECLARE FUNCTION Get.Color& (Col)
DECLARE SUB Draw.Window95 (WinID, Style)
DECLARE SUB Draw.WindowXP (WinID, Style)
DECLARE SUB Draw.Button95 (ButID, Style)
DECLARE SUB Draw.ButtonXP (ButID, Style)
DECLARE SUB SaveBMP (X1%, Y1%, x2%, y2%, FileName$)
DECLARE FUNCTION New.Window (Xpos, Ypos, XSize, YSize, Title$)
DECLARE FUNCTION Get.ActiveWin ()
DECLARE SUB Set.ActiveWin (WinID)
DECLARE FUNCTION Check.OverLap (TopWindow, BackWindow)
DECLARE FUNCTION Get.OnWindow ()
DECLARE FUNCTION New.Button (XSize, YSize, ButtonType)
DECLARE FUNCTION Get.ObjectValue (Object, Xpos, Ypos, WindowObject, Specification$, Parameter, PreviousValue)
DECLARE FUNCTION Get.ObjectType (Object)
DECLARE FUNCTION On.Target (Xpos, Ypos, X1pos, Y1pos)
DECLARE SUB CloseWindow (WindowObject)
DECLARE SUB Change.InterFace (InterF)

CONST False = 0, True = -1, Disable = -2, Enable = 0
CONST Desktop = 1, Wind = 2, Button = 3
CONST Windows95 = 1, WindowsXP = 2
CONST Frames = 27, SystemObject = -1
CONST MouseAway = 1, MouseOver = 2, MouseON = 3
CONST ShowFramesPerSecond = 27

TYPE databaseVariables
   ControlType AS INTEGER
   ControlID AS INTEGER
END TYPE
TYPE WindowVariables
   Xpos AS INTEGER
   Ypos AS INTEGER
   XSize AS INTEGER
   YSize AS INTEGER
   Order AS INTEGER
   WindowContents AS INTEGER
   Status AS INTEGER
   EMSPage AS INTEGER
   DataBaseEntry AS INTEGER
END TYPE
TYPE ButtonVariables
   XSize AS INTEGER
   YSize AS INTEGER
   ButtonText(5) AS LONG
   Temp AS INTEGER
   ButtonType AS INTEGER
END TYPE

COMMON SHARED InterFace, FrameCount!
COMMON SHARED Xres, Yres, BitDeph, WinDataBaseCount
COMMON SHARED BackGround, NeedToReDraw, ActivePage
COMMON SHARED ProcessID, InProcess, Done, MouseChanged
COMMON SHARED EMSPageCount, ObjectCount
COMMON SHARED Error$, Temp1, Temp2, Temp3, Temp4
COMMON SHARED MouseX, MouseY, MouseR, MouseL, Key$
COMMON SHARED OldMouseX, OldMouseY, OnWindow
COMMON SHARED Win() AS WindowVariables
COMMON SHARED WinTitle() AS STRING
COMMON SHARED WinOrder(), ButtonCount
COMMON SHARED But() AS ButtonVariables
COMMON SHARED DataBase() AS databaseVariables
COMMON SHARED ActiveWin, OldActiveWin, WinCount
COMMON SHARED Border, Head, DObject, DoSpec
COMMON SHARED ClButton, CloseButton, PrWin
'$INCLUDE: 'future.bi'
DIM SHARED Win(0) AS WindowVariables
DIM SHARED DataBase(0) AS databaseVariables
DIM SHARED WinOrder(0)
DIM SHARED WinTitle(0) AS STRING
DIM SHARED But(0) AS ButtonVariables
RANDOMIZE TIMER

IF Initalise(800, 600, 16, WindowsXP, "Loading WizGui 2") = False THEN
   PRINT "Error occured while loading WizGui:"
   PRINT Error$
   PRINT "Press any key to select diffrent mode"
   CLEAR
   END
END IF
IF Draw.Object(Desktop, 0) = True THEN
   Future.CLS RGB2Color(0, 40, 80)
   End.DrawObject
END IF

Window1 = New.Window(20, 30, 200, 300, "Buttons (Window 1)")
Window2 = New.Window(120, 130, 200, 90, "Data...(Window 2)")
Window3 = New.Window(220, 330, 300, 210, "Graphics...(Window 3)")
button1 = New.Button(80, 0, 1)
button2 = New.Button(150, 0, 1)

IF Draw.Object(Window2, 0) = True THEN
   X = Border
   Y = 2 * Border + Head'
   Future.Print X + 5, Y + 5, "Mouse X:", 0, -1
   Future.Print X + 5, Y + 21, "Mouse Y:", 0, -1
   Future.Print X + 5, Y + 37, "Mouse On: ", 0, -1
   End.DrawObject
END IF
IF Draw.Object(Window3, 0) = True THEN
   Future.CLS 0
   End.DrawObject
END IF

Emsp1 = DataBase(Window3).ControlID
Emsp2 = DataBase(Window2).ControlID

Value1 = Disable
Value2 = Enable
Future.MouseOn
DO
   X = Border
   Y = 2 * Border + Head
   But1 = Get.ObjectValue(button2, 10, 10, Window1, "Windows 95 style", Value2, But1)
   But2 = Get.ObjectValue(button2, 10, 40, Window1, "Windows XP style", Value1, But2)
   But3 = Get.ObjectValue(button1, 10, 70, Window1, "Button 1", 0, But3)
   But4 = Get.ObjectValue(button1, 10, 100, Window1, "Button 2", Disable, But4)

   Ex = Get.ObjectValue(button1, Xres - 90, Yres - 30, Desktop, "Exit", 0, Ex)
   IF Win(Emsp1).Status = True THEN
      SetEMSPage Emsp1
         Xpos = Win(Emsp1).XSize - (2 * Border)
         Ypos = Win(Emsp1).YSize - (3 * Border) - Head
         Future.Line RND * Xpos + X, RND * Ypos + Y, RND * Xpos + X, RND * Ypos + Y, Get.Color(RND * 15), -1
      SetPage ActivePage
   END IF
   IF Win(Emsp2).Status = True THEN
      SetEMSPage Emsp2
         IF MouseChanged = True THEN
            Col& = Future.POINT(X + 1, Y + 1)
            Future.Print X + 70, Y + 5, STR$(MouseX) + "  ", 0, Col&
            Future.Print X + 70, Y + 21, STR$(MouseY) + "  ", 0, Col&
            IF OnWindow > 0 THEN Target$ = "Window" + STR$(OnWindow)
            IF OnWindow = 0 THEN Target$ = "Desktop "
            Future.Print X + 80, Y + 37, Target$, 0, Col&
         END IF
      SetPage ActivePage
   END IF
   IF Ex = 3 THEN EXIT DO
   IF But1 = 3 THEN
      SWAP Value1, Value2
      Change.InterFace Windows95
   END IF
   IF But2 = 3 THEN
      SWAP Value1, Value2
      Change.InterFace WindowsXP
   END IF
   Run.Gui
   IF ClButton = 3 THEN CloseWindow ActiveWin
LOOP UNTIL Key$ = CHR$(27)
End.Gui

SUB Change.InterFace (InterF)
IF InterFace = InterF THEN EXIT SUB
IF BitDeph = 8 THEN EXIT SUB
Set.ActiveWin 0

OldBorder = Border
OldHead = Head
InterFace = InterF

IF InterFace = WindowsXP THEN
   TempColor& = Get.Color(7)
   Border = 3
   Head = 24
END IF
IF InterFace = Windows95 THEN
   TempColor& = RGB2Color(239, 235, 222)
   Border = 3
   Head = 18
END IF

IF InterFace = Windows95 THEN
     CloseButton = New.Button(13, 13, 0)
     IF Draw.Object(CloseButton, MouseAway) = True THEN
        ButID = DataBase(CloseButton).ControlID
        Draw.Button95 ButID, 1
        Future.Print 3, -1, "", 0, -1
        End.DrawObject
     END IF
     IF Draw.Object(CloseButton, MouseON) = True THEN
        Draw.Button95 ButID, 3
        Future.Print 3, -1, "", Get.Color(15), -1
        End.DrawObject
     END IF
     IF Draw.Object(CloseButton, MouseOver) = True THEN
        Draw.Button95 ButID, 2
        Future.Print 3, -1, "", Get.Color(15), -1
        End.DrawObject
     END IF
END IF

IF InterFace = WindowsXP THEN
     CloseButton = New.Button(20, 20, 0)
     ButID = DataBase(CloseButton).ControlID
     IF Draw.Object(CloseButton, MouseAway) = True THEN
        Future.LoadBMP "Maway.bmp", 0, 0
        End.DrawObject
     END IF
     IF Draw.Object(CloseButton, MouseON) = True THEN
        Future.LoadBMP "Mon.bmp", 0, 0
        End.DrawObject
     END IF
     IF Draw.Object(CloseButton, MouseOver) = True THEN
        Future.LoadBMP "Mover.bmp", 0, 0
        End.DrawObject
     END IF
END IF




IF WinCount > 0 THEN
   FOR Count = 1 TO WinCount
      IF Win(Count).Status = True THEN
         WinXSize = Win(Count).XSize - (2 * OldBorder)
         WinYSize = Win(Count).YSize - ((3 * OldBorder) + OldHead)
         WinTemp = AllExpMem(SizeOf(WinXSize, WinYSize))
         SetPage 2
         Future.EMSPutx 0, 0, Win(Count).WindowContents, OldBorder, 2 * OldBorder + OldHead, Win(Count).XSize - OldBorder, Win(Count).YSize - OldBorder
         Future.EMSGet 0, 0, WinXSize, WinYSize, WinTemp
         DeAllEXPMem Win(Count).WindowContents
         XSize = WinXSize + (2 * Border)
         YSize = WinYSize + ((3 * Border) + Head)
         Win(Count).XSize = XSize
         Win(Count).YSize = YSize
         Win(Count).WindowContents = AllExpMem(SizeOf(XSize, YSize))
         DefineEMSBufferSize Win(Count).WindowContents, XSize, YSize, Count


         IF InterFace = WindowsXP THEN Draw.WindowXP Count, 1
         IF InterFace = Windows95 THEN Draw.Window95 Count, 1

         SetEMSPage Count
         Xpos = Border
         Ypos = (2 * Border) + Head
         SetMaskColor TempColor&
            Future.EMSPut Xpos, Ypos, WinTemp
         SetMaskColor -1
         DeAllEXPMem WinTemp
      END IF
   NEXT Count
   SetPage ActivePage
END IF

IF ButtonCount > 0 THEN
   FOR Count = 1 TO ButtonCount
      IF But(Count).ButtonType = SystemObject THEN
         SetPage 2
         FOR SubCount = 1 TO 4
            Future.CLS 0
            IF InterFace = Windows95 THEN Draw.Button95 Count, SubCount
            IF InterFace = WindowsXP THEN Draw.ButtonXP Count, SubCount
            future.EMSArrayGet 0, 0, But(Count).Temp, SubCount - 1
         NEXT SubCount
      END IF
   NEXT Count
END IF

Done = -3
SwichPage
   Future.EMSPut 0, 0, BackGround
   RefreshWindows 1, WinCount
viewPage ActivePage
SwichPage
Future.EMSPut 0, 0, BackGround
SwichPage
END SUB

SUB CloseWindow (WinID)
IF Win(WinID).Status = 0 THEN EXIT SUB
IF ActiveWin <> WinID THEN Set.ActiveWin WinID
Xpos = Win(WinID).Xpos
Ypos = Win(WinID).Ypos
X1pos = Xpos + Win(WinID).XSize
Y1pos = Ypos + Win(WinID).YSize
FOR PageCount = 1 TO 2
   SwichPage
      Future.EMSPutx Xpos, Ypos, BackGround, Xpos, Ypos, X1pos, Y1pos
      RefreshWindows 1, WinCount - 1
   viewPage ActivePage
NEXT PageCount
DBEntry = Win(WinID).DataBaseEntry
DataBase(DBEntry).ControlType = 0
DataBase(DBEntry).ControlID = 0

WinTitle(WinID) = ""
Win(WinID).Xpos = 0
Win(WinID).Ypos = 0
Win(WinID).XSize = 0
Win(WinID).YSize = 0
Win(WinID).Status = False
Win(WinID).Order = 0
Win(WinID).DataBaseEntry = 0
DeAllEXPMem Win(WinID).WindowContents
Win(WinID).WindowContents = 0
WinCount = WinCount - 1
REDIM PRESERVE WinOrder(WinCount)
ActiveWin = 0
END SUB

SUB Draw.Button95 (ButID, Style)
Xpos = 0
Ypos = 0
X1pos = But(ButID).XSize
Y1pos = But(ButID).YSize
IF Style <> 3 THEN
   Future.FillBox Xpos, Ypos, X1pos, Y1pos, Get.Color(7)
   Future.Box Xpos, Ypos, X1pos, Y1pos, Get.Color(0)
   Future.Box Xpos + 1, Ypos + 1, X1pos - 1, Y1pos - 1, Get.Color(8)
   Future.Line Xpos, Ypos, X1pos - 1, Ypos, Get.Color(15), -1
   Future.Line Xpos, Ypos, Xpos, Y1pos - 1, Get.Color(15), -1
   Future.Line Xpos + 1, Ypos + 1, X1pos - 2, Ypos + 1, Get.Color(7), -1
   Future.Line Xpos + 1, Ypos + 1, Xpos + 1, Y1pos - 2, Get.Color(7), -1
   SELECT CASE Style
      CASE 1
         But(ButID).ButtonText(1) = Get.Color(0)
      CASE 2
         But(ButID).ButtonText(2) = Get.Color(15)
      CASE 4
         But(ButID).ButtonText(4) = Get.Color(8)
         But(ButID).ButtonText(5) = Get.Color(15)
   END SELECT
END IF
IF Style = 3 THEN
   Future.FillBox Xpos, Ypos, X1pos, Y1pos, Get.Color(7)
   Future.Box Xpos, Ypos, X1pos, Y1pos, Get.Color(15)
   Future.Box Xpos + 1, Ypos + 1, X1pos - 1, Y1pos - 1, Get.Color(7)
   Future.Line Xpos, Ypos, X1pos - 1, Ypos, Get.Color(0), -1
   Future.Line Xpos, Ypos, Xpos, Y1pos - 1, Get.Color(0), -1
   Future.Line Xpos + 1, Ypos + 1, X1pos - 2, Ypos + 1, Get.Color(8), -1
   Future.Line Xpos + 1, Ypos + 1, Xpos + 1, Y1pos - 2, Get.Color(8), -1
   But(ButID).ButtonText(3) = Get.Color(15)
END IF
END SUB

SUB Draw.ButtonXP (ButID, Style)
Xpos = 0
Ypos = 0
X1pos = But(ButID).XSize
Y1pos = But(ButID).YSize
YSize = Y1pos
FealdSize = YSize / 4
But(ButID).ButtonText(Style) = 0
SELECT CASE Style
      CASE 1 TO 2
         
         Col& = RGB2Color(0, 60, 115)
         Future.Box Xpos, Ypos, X1pos, Y1pos, Col&

         Size = YSize - 2
         RedStep! = (255 - 218) / Size
         GreenStep! = (255 - 215) / Size
         BlueStep! = (255 - 198) / Size

         FOR Count = 1 TO Size + 1
            R = 255 - (RedStep! * Count)
            G = 255 - (GreenStep! * Count)
            B = 255 - (BlueStep! * Count)
            Future.HLINE Count, 1, X1pos - 1, RGB2Color(R, G, B)
         NEXT

         IF Style = 2 THEN
            Future.Line Xpos + 1, Y1pos - 1, X1pos - 1, Y1pos - 1, RGB2Color(243, 165, 25), -1
            Future.Line Xpos + 1, Y1pos - 2, X1pos - 1, Y1pos - 2, RGB2Color(243, 165, 25), -1


            Future.Pset Xpos + 1, Y1pos - 3, RGB2Color(243, 165, 25)
            Future.Pset Xpos + 2, Y1pos - 3, RGB2Color(243, 165, 25)
            Future.Pset X1pos - 1, Y1pos - 3, RGB2Color(243, 165, 25)
            Future.Pset X1pos - 2, Y1pos - 3, RGB2Color(243, 165, 25)

            MX = (YSize - 7) / 2
            Future.FillBox Xpos + 1, Y1pos - 4, Xpos + 2, Y1pos - 4 - MX, RGB2Color(254, 193, 81)
            Future.FillBox X1pos - 1, Y1pos - 4, X1pos - 2, Y1pos - 4 - MX, RGB2Color(254, 193, 81)
            Future.FillBox Xpos + 1, Ypos + 2, Xpos + 2, Y1pos - 4 - MX, RGB2Color(255, 217, 137)
            Future.FillBox X1pos - 1, Ypos + 2, X1pos - 2, Y1pos - 4 - MX, RGB2Color(255, 217, 137)
            Future.Line Xpos + 1, Ypos + 2, X1pos - 1, Ypos + 2, RGB2Color(255, 217, 137), -1
            Future.Line Xpos + 1, Ypos + 1, X1pos - 1, Ypos + 1, RGB2Color(255, 243, 206), -1

         END IF
      CASE 3
         
         Col& = RGB2Color(0, 60, 115)
         Future.Box Xpos, Ypos, X1pos, Y1pos, Col&
         Future.FillBox Xpos + 1, Ypos + 1, X1pos - 1, Y1pos - 1, RGB2Color(210, 210, 210)
         posit = 3
         Future.Line Xpos + posit, Ypos + posit, X1pos - posit, Ypos + posit, 0, &HCCCC
         Future.Line Xpos + posit, Y1pos - posit, X1pos - posit, Y1pos - posit, 0, &HCCCC
         Future.Line Xpos + posit, Ypos + posit, Xpos + posit, Y1pos - posit, 0, &HCCCC
         Future.Line X1pos - posit, Ypos + posit, X1pos - posit, Y1pos - posit, 0, &HCCCC
      CASE 4
         Future.FillBox Xpos, Ypos, X1pos, Y1pos, RGB2Color(247, 247, 239)
         Future.Box Xpos, Ypos, X1pos, Y1pos, RGB2Color(206, 199, 189)
         But(ButID).ButtonText(Style) = RGB2Color(165, 162, 148)
END SELECT
END SUB

FUNCTION Draw.Object (Object, Specification)
IF Object = Desktop OR DataBase(Object).ControlType = Wind THEN
   IF Object = 0 THEN
      Target = 0
      ELSE WinID = DataBase(Object).ControlID
   END IF
   CALL SetEMSPage(WinID)
   Draw.Object = True
   IF WinID > 0 THEN
      Xpos = Border
      Ypos = Border + Head + Border
      X1pos = Win(WinID).XSize - Border
      Y1pos = Win(WinID).YSize - Border
      SetViewPort Xpos, Ypos, X1pos + 1, Y1pos + 1
   END IF
   EXIT FUNCTION
END IF

IF DataBase(Object).ControlType = Button THEN
   SetPage 2
   Future.CLS 0
   DObject = Object
   DoSpec = Specification
   Draw.Object = True
   EXIT FUNCTION
END IF

Draw.Object = False
END FUNCTION

SUB Draw.Window95 (WinID, Style)
SetEMSPage WinID
   Xpos = 0
   Ypos = 0
   X1pos = Win(WinID).XSize
   Y1pos = Win(WinID).YSize
   SELECT CASE Style
      CASE 1 TO 2
         IF Style = 1 THEN
            Future.CLS Get.Color(7)
            Future.Line Xpos + 1, Ypos + 1, Xpos + 1, Y1pos - 1, Get.Color(15), -1
            Future.Line Xpos + 1, Ypos + 1, X1pos - 1, Ypos + 1, Get.Color(15), -1
            Future.HLINE Y1pos - 1, Xpos + 1, X1pos - 1, Get.Color(8)
            Future.Line X1pos - 1, Ypos + 1, X1pos - 1, Y1pos - 1, Get.Color(8), -1
            Future.HLINE Y1pos, Xpos, X1pos, Get.Color(0)
            Future.Line X1pos, Ypos, X1pos, Y1pos, Get.Color(0), -1
            
         END IF
         TitleBar& = Get.Color(8)
         TitleText& = Get.Color(7)
      CASE 3
         TitleBar& = Get.Color(1)
         TitleText& = Get.Color(15)
   END SELECT

   Future.FillBox Xpos + Border, Ypos + Border, X1pos - Border, Ypos + Border + Head, TitleBar&
   Future.Print Xpos + Border + 4, Ypos + Border + (Head / 2) - 7, WinTitle(WinID), TitleText&, -1

   ClButton = Get.ObjectValue(CloseButton, X1pos - 22, -Border - Head + 3, Win(WinID).DataBaseEntry, "", 0, 0)
SetPage ActivePage
END SUB

SUB Draw.WindowXP (WinID, Style)
SetEMSPage WinID
   Xpos = 0
   Ypos = 0
   X1pos = Win(WinID).XSize
   Y1pos = Win(WinID).YSize
   SELECT CASE Style
      CASE 1 TO 2
         IF Style = 1 THEN Future.CLS RGB2Color(239, 235, 222)

         Future.Box Xpos, Ypos, X1pos, Y1pos, RGB2Color(59, 95, 183)
         Future.Box Xpos + 1, Ypos + 1, X1pos - 1, Y1pos - 1, RGB2Color(102, 119, 207)
         Future.Box Xpos + 2, Ypos + 2, X1pos - 2, Y1pos - 2, RGB2Color(122, 133, 199)
         Future.Line Xpos, Ypos, Xpos, Y1pos, RGB2Color(80, 109, 201), -1
         Future.Line Xpos + 1, Ypos, Xpos + 1, Y1pos - 1, RGB2Color(116, 127, 216), -1
         Future.Line Xpos + 2, Ypos, Xpos + 2, Y1pos - 2, RGB2Color(80, 109, 201), -1

         DIM CDB(29) AS LONG
         CDB(1) = RGB2Color(140, 147, 214)
         CDB(2) = RGB2Color(147, 178, 243)
         CDB(3) = RGB2Color(154, 184, 244)
         CDB(4) = RGB2Color(141, 173, 232)
         CDB(5) = RGB2Color(129, 163, 227)
         CDB(6) = RGB2Color(123, 156, 225)

         CDB(7) = RGB2Color(123, 153, 255)
         CDB(8) = RGB2Color(122, 152, 224)
         CDB(9) = RGB2Color(122, 150, 223)
         CDB(10) = RGB2Color(122, 151, 223)
         CDB(11) = RGB2Color(121, 151, 223)
         CDB(12) = RGB2Color(122, 152, 224)
         CDB(13) = RGB2Color(123, 151, 225)
         CDB(14) = RGB2Color(123, 151, 224)

         CDB(15) = RGB2Color(123, 153, 223)
         CDB(16) = RGB2Color(123, 153, 223)
         CDB(17) = RGB2Color(126, 156, 226)
         CDB(18) = RGB2Color(127, 157, 227)
         CDB(19) = RGB2Color(127, 160, 229)
         CDB(20) = RGB2Color(128, 163, 231)

         CDB(21) = RGB2Color(127, 164, 232)
         CDB(22) = RGB2Color(129, 166, 234)
         CDB(23) = RGB2Color(130, 169, 234)
         CDB(24) = RGB2Color(130, 169, 234)
         CDB(25) = RGB2Color(128, 167, 232)
         CDB(26) = RGB2Color(128, 166, 231)

         CDB(27) = RGB2Color(127, 157, 227)
         CDB(28) = RGB2Color(124, 148, 210)
         CDB(29) = RGB2Color(134, 149, 190)
         FOR Count = 1 TO 29
            Future.HLINE Count - 1, Xpos + 1, X1pos - 1, CDB(Count)
         NEXT
         Future.HLINE 29, Xpos + 1, X1pos - 1, CDB(29)
         TextCol& = Get.Color(15)
      CASE 3
         Future.Box Xpos, Ypos, X1pos, Y1pos, RGB2Color(0, 16, 140)
         Future.Box Xpos + 1, Ypos + 1, X1pos - 1, Y1pos - 1, RGB2Color(0, 28, 165)
         Future.Box Xpos + 2, Ypos + 2, X1pos - 2, Y1pos - 2, RGB2Color(0, 73, 247)
         Future.Line Xpos, Ypos, Xpos, Y1pos, RGB2Color(8, 48, 222), -1
         Future.Line Xpos + 1, Ypos, Xpos + 1, Y1pos - 1, RGB2Color(16, 105, 230), -1
         Future.Line Xpos + 2, Ypos, Xpos + 2, Y1pos - 2, RGB2Color(8, 85, 222), -1

         DIM CDB(29) AS LONG
         CDB(1) = RGB2Color(0, 89, 239)
         CDB(2) = RGB2Color(57, 150, 255)
         CDB(3) = RGB2Color(41, 146, 255)
         CDB(4) = RGB2Color(0, 113, 255)
         CDB(5) = RGB2Color(0, 101, 247)
         CDB(6) = RGB2Color(0, 93, 239)
         FOR Count = 7 TO 14
            CDB(Count) = RGB2Color(0, 85, 231)
         NEXT
         CDB(15) = RGB2Color(0, 85, 239)
         CDB(16) = RGB2Color(0, 85, 239)
         CDB(17) = RGB2Color(0, 89, 239)
         CDB(18) = RGB2Color(0, 89, 247)
         CDB(19) = RGB2Color(0, 89, 247)
         CDB(20) = RGB2Color(0, 97, 255)
         CDB(21) = RGB2Color(0, 101, 255)
         FOR Count = 22 TO 26
            CDB(Count) = RGB2Color(0, 105, 255)
         NEXT
         CDB(27) = RGB2Color(0, 97, 255)
         CDB(28) = RGB2Color(0, 77, 231)
         CDB(29) = RGB2Color(0, 65, 206)
         FOR Count = 1 TO 29
            Future.HLINE Count - 1, Xpos + 1, X1pos - 1, CDB(Count)
         NEXT
         Future.HLINE 29, Xpos + 1, X1pos - 1, CDB(29)
         TextCol& = Get.Color(15)
   END SELECT
   Future.Print Xpos + Border + 4, Ypos + Border + (Head / 2) - 7, WinTitle(WinID), TextCol&, -1
   'But1 = Get.ObjectValue(button2, 10, 10, Window1, "Change interface", 0, But1)
   SetMaskColor 0
      ClButton = Get.ObjectValue(CloseButton, X1pos - 29, -Border - Head + 2, Win(WinID).DataBaseEntry, "", 0, 0)
   SetMaskColor -1
SetPage ActivePage
END SUB

SUB End.DrawObject
IF DObject = 0 THEN
   SetPage ActivePage
   NeedToReDraw = True
   SetViewPort 0, 0, Xres, Yres
   EXIT SUB
ELSE
   ObjectType = Get.ObjectType(DObject)
   SetPage 2
   IF ObjectType = Button THEN
      ButID = DataBase(DObject).ControlID
      future.EMSArrayGet 0, 0, But(ButID).Temp, DoSpec - 1
   END IF
   DObject = False
   SetPage ActivePage
END IF

END SUB

SUB End.Gui
FreeAllExpMem
ReSetScreen
CLS
END SUB

FUNCTION Get.ActiveWin
IF WinCount > 0 THEN
   Check = WinCount
   DO
      WinID = WinOrder(Check)
      Xpos = Win(WinID).Xpos
      Ypos = Win(WinID).Ypos
      X1pos = Win(WinID).XSize + Win(WinID).Xpos
      Y1pos = Win(WinID).YSize + Win(WinID).Ypos
      IF On.Target(Xpos, Ypos, X1pos, Y1pos) = True THEN
         Get.ActiveWin = WinID
         EXIT FUNCTION
      END IF
      Check = Check - 1
   LOOP UNTIL Check = 0
END IF
Get.ActiveWin = 0
END FUNCTION

FUNCTION Get.Color& (Col)
SELECT CASE BitDeph
CASE 8
   Get.Color& = Col
CASE IS > 8
   SELECT CASE Col
   CASE 1
      Get.Color& = RGB2Color(0, 0, 170)
   CASE 2
      Get.Color& = RGB2Color(0, 170, 0)
   CASE 3
      Get.Color& = RGB2Color(0, 170, 170)
   CASE 4
      Get.Color& = RGB2Color(170, 0, 0)
   CASE 5
      Get.Color& = RGB2Color(170, 0, 170)
   CASE 6
      Get.Color& = RGB2Color(170, 85, 0)
   CASE 7
      Get.Color& = RGB2Color(170, 170, 170)
   CASE 8
      Get.Color& = RGB2Color(85, 85, 85)
   CASE 9
      Get.Color& = RGB2Color(85, 85, 255)
   CASE 10
      Get.Color& = RGB2Color(85, 255, 85)
   CASE 11
      Get.Color& = RGB2Color(85, 255, 255)
   CASE 12
      Get.Color& = RGB2Color(255, 85, 85)
   CASE 13
      Get.Color& = RGB2Color(255, 85, 255)
   CASE 14
      Get.Color& = RGB2Color(255, 255, 85)
   CASE 15
      Get.Color& = RGB2Color(255, 255, 255)
   END SELECT
END SELECT

END FUNCTION

FUNCTION Get.ObjectType (Object)
SELECT CASE Object
   CASE IS > ObjectCount
      Get.ObjectType = False
   CASE ELSE
      Get.ObjectType = DataBase(Object).ControlType
END SELECT

END FUNCTION

FUNCTION Get.ObjectValue (Object, Xpos, Ypos, Win, Specification$, Parameter, PreviousValue)

'Check if Done is True

IF Parameter = Disable AND PreviousValue = -2 AND Done > -2 THEN
   Get.ObjectValue = -2
   EXIT FUNCTION
END IF

IF Done = True AND PreviousValue = -1 AND Parameter <> Disable THEN
   Get.ObjectValue = PreviousValue
   EXIT FUNCTION
END IF

IF Get.ObjectType(Win) = Wind OR Get.ObjectType(Win) = Desktop THEN
   SELECT CASE Get.ObjectType(Object)
      CASE Button
         ButID = DataBase(Object).ControlID
         WinID = DataBase(Win).ControlID
         EMSPage = WinID
         IF Done > -2 THEN Done = False
         IF WinID > 0 THEN
            Xpos = Xpos + Border
            Ypos = Ypos + (2 * Border) + Head
            Mouse.X = Win(WinID).Xpos
            Mouse.Y = Win(WinID).Ypos
         END IF
         X1pos = Xpos + But(ButID).XSize
         Y1pos = Ypos + But(ButID).YSize
         IF Parameter = Disable THEN
            Get.ObjectValue = -2
            DrawButtonStyle = 4
            GOSUB DrawButton
         END IF
         IF OnWindow <> WinID AND Done > -2 THEN
            Get.ObjectValue = -1
            IF Done > -2 THEN Done = False
            SELECT CASE PreviousValue
               CASE IS <> -1
                  DrawButtonStyle = 1
                  GOSUB DrawButton
            END SELECT
            EXIT FUNCTION
         ELSE
            SELECT CASE On.Target(Xpos + Mouse.X, Ypos + Mouse.Y, X1pos + Mouse.X, Y1pos + Mouse.Y)
               CASE True
                  IF Done > -2 THEN Done = True
                  IF MouseL = True THEN
                     ButtonValue = 2
                     DrawButtonStyle = 3
                  ELSE
                     DrawButtonStyle = 2
                     IF PreviousValue = 2 THEN
                        ButtonValue = 3
                     ELSE
                        ButtonValue = 1
                     END IF
                  END IF
               CASE False
                  IF Done > -2 THEN Done = False
                  ButtonValue = -1
                  DrawButtonStyle = 1
            END SELECT
            Get.ObjectValue = ButtonValue
            IF ButtonValue = PreviousValue AND Done > -2 THEN EXIT FUNCTION
            IF PreviousValue = 3 AND ButtonValue = 1 AND Done > -2 THEN EXIT FUNCTION
            GOSUB DrawButton:
         END IF
   END SELECT
END IF
EXIT FUNCTION

DrawButton:
SetEMSPage EMSPage
future.EMSArrayPut Xpos, Ypos, But(ButID).Temp, DrawButtonStyle - 1
Text$ = Specification$
TextX = Xpos + ((But(ButID).XSize) / 2) - (LEN(Text$) * 4)
TextY = Ypos + ((But(ButID).YSize) / 2) - 7
IF DrawButtonStyle = 4 AND InterFace = Windows95 THEN
   Future.Print TextX + 1, TextY + 1, Text$, But(ButID).ButtonText(DrawButtonStyle + 1), -1
END IF
Future.Print TextX, TextY, Text$, But(ButID).ButtonText(DrawButtonStyle), -1
SetPage ActivePage

IF WinID = 0 THEN
    SwichPage
       Future.EMSPutx Xpos, Ypos, BackGround, Xpos, Ypos, X1pos, Y1pos
       RefreshWindows 1, WinCount
    viewPage ActivePage
    SwichPage
      Future.EMSPutx Xpos, Ypos, BackGround, Xpos, Ypos, X1pos, Y1pos
    SwichPage
END IF
EXIT FUNCTION

END FUNCTION

FUNCTION Get.OnWindow
IF WinCount > 0 THEN
   Check = WinCount
   DO
      WinID = WinOrder(Check)
      Xpos = Win(WinID).Xpos + Border
      Ypos = Win(WinID).Ypos + (2 * Border) + Head
      X1pos = Win(WinID).XSize + Win(WinID).Xpos - Border
      Y1pos = Win(WinID).YSize + Win(WinID).Ypos - Border
      IF On.Target(Xpos, Ypos, X1pos, Y1pos) = True THEN
         'IF CheckOrder < Check THEN
         '   CheckOrder = Check
         Get.OnWindow = WinID
         EXIT FUNCTION
         'END IF
      END IF
      Check = Check - 1
   LOOP UNTIL Check = 0
END IF
Get.OnWindow = 0

END FUNCTION

FUNCTION Initalise (Xr, Yr, Deph, SetInterFace, LoadText$)

'Check WizGui system requaments. EMS and XMS memory support, Vesa and
'selected mode existence. If there is no problems then set up WizGui

CLS
Error$ = ""
'Check for Vesa:
 IF IsVESA = False THEN Error$ = Error$ + "100:100 -> No Vesa support found!" + CHR$(13): Videoerror = True

'Check if selected screen mode exist:
 CheckMode$ = LTRIM$(STR$(Xr)) + "x" + LTRIM$(STR$(Yr)) + STR$(Deph) + " Bit"
 FOR i% = 0 TO 1024
    ModeFound$ = Future.ModeList$(i%)
    IF ModeFound$ = "" THEN EXIT FOR
    IF INSTR(ModeFound$, CheckMode$) THEN ModeFound = True: EXIT FOR
 NEXT
 IF ModeFound = 0 THEN ModeFound = False
 IF ModeFound = False THEN Error$ = Error$ + "100:200 -> Mode " + CheckMode$ + " is not supported by your video card!" + CHR$(13): Videoerror = True
 CheckMode$ = ""

'Check if EMS is installed:
 IF IsEMMInstalled = False THEN Error$ = Error$ + "200:100 -> No EMS memory found!" + CHR$(13)

'Check for the mouse:
 IF MouseInit = True THEN Error$ = Error$ + "300:100 -> Mouse not found!" + CHR$(13)

'Set screen mode and check for aviable video pages:
 IF Videoerror = False THEN
    CALL SetScreenMode(Xr, Yr, Deph)
    IF Pages < 2 THEN
       Error$ = Error$ + "100:300 -> Not enough video pages (At least 2 are needed)!" + CHR$(13)
    END IF
 END IF

'if there is error then Initalise = False and exit function.
 IF Error$ > "" THEN
    ReSetScreen
    SCREEN 0
    Initalise = False
    EXIT FUNCTION
 END IF

'If there is no error then Initalise=True and loading will continue!
 Initalise = True

'Start WizGui

 'Ceck for MMX support
  IF IsMMX = True THEN SetMMX 1

 'Set up variables
  Xres = Xr
  Yres = Yr
  BitDeph = Deph
  ActivePage = 0
  SetPage ActivePage
  
 'Print Loading Text if there is one
  IF LoadText$ > "" THEN
     Xloc = (Xres / 2) - (LEN(LoadText$) * 4)
     Yloc = (Yres / 2) - 8
     CALL Future.Print(Xloc, Yloc, LoadText$, Get.Color(2), 0)
  END IF

 'Expand DataBase
  ObjectCount = ObjectCount + 1
  REDIM PRESERVE DataBase(ObjectCount) AS databaseVariables
  DataBase(ObjectCount).ControlType = Desktop
  DataBase(ObjectCount).ControlID = 0

 'Initalise screen buffer (it's located in EMS memory)
  BackGround = AllExpMem(SizeOf(Xres, Yres))
  CALL DefineEMSBufferSize(BackGround, Xres, Yres, 0)
  SetEMSPage 0
     Future.CLS (0)
  SetPage 0

 'Set mouse cursor to the middle of the screen:
  CALL SetLocation(Xres / 2, Yres / 2)
  
 'Set Interface
  IF Deph = 8 OR SetInterFace = Windows95 THEN
     InterFace = Windows95
     CloseButton = New.Button(13, 13, 0)
     ButID = DataBase(CloseButton).ControlID
     IF Draw.Object(CloseButton, MouseAway) = True THEN
        Draw.Button95 ButID, 1
        Future.Print 3, -1, "", 0, -1
        End.DrawObject
     END IF
     IF Draw.Object(CloseButton, MouseON) = True THEN
        Draw.Button95 ButID, 3
        Future.Print 3, -1, "", Get.Color(15), -1
        End.DrawObject
     END IF
     IF Draw.Object(CloseButton, MouseOver) = True THEN
        Draw.Button95 ButID, 2
        Future.Print 3, -1, "", Get.Color(15), -1
        End.DrawObject
     END IF
     Border = 3
     Head = 18
  ELSE
     InterFace = SetInterFace
     Border = 3
     Head = 24
     CloseButton = New.Button(20, 20, 0)
     IF Draw.Object(CloseButton, MouseAway) = True THEN
        Future.LoadBMP "Maway.bmp", 0, 0
        End.DrawObject
     END IF
     IF Draw.Object(CloseButton, MouseON) = True THEN
        Future.LoadBMP "Mon.bmp", 0, 0
        End.DrawObject
     END IF
     IF Draw.Object(CloseButton, MouseOver) = True THEN
        Future.LoadBMP "Mover.bmp", 0, 0
        End.DrawObject
     END IF
  END IF
END FUNCTION

FUNCTION New.Button (XSize, YSize, ButtonType)
   ObjectCount = ObjectCount + 1
   ButtonCount = ButtonCount + 1
   New.Button = ObjectCount

   REDIM PRESERVE DataBase(ObjectCount)  AS databaseVariables
   REDIM PRESERVE But(ButtonCount) AS ButtonVariables
   DataBase(ObjectCount).ControlType = Button
   DataBase(ObjectCount).ControlID = ButtonCount

   IF XSize = 0 THEN XSize = 80
   IF YSize = 0 THEN YSize = 22

   But(ButtonCount).XSize = XSize
   But(ButtonCount).YSize = YSize

   But(ButtonCount).Temp = AllExpMem(4 * (SizeOf(XSize, YSize) - 4))
   Future.DefineEMSArray XSize + 1, YSize + 1, But(ButtonCount).Temp

   IF ButtonType = 1 THEN
      But(ButtonCount).ButtonType = SystemObject
      SetPage 2
      FOR Count = 1 TO 4
         Future.CLS 0
         IF InterFace = Windows95 THEN Draw.Button95 ButtonCount, Count
         IF InterFace = WindowsXP THEN Draw.ButtonXP ButtonCount, Count
         future.EMSArrayGet 0, 0, But(ButtonCount).Temp, Count - 1
      NEXT Count
      SetPage ActivePage
   END IF
END FUNCTION

FUNCTION New.Window (Xpos, Ypos, XSize, YSize, Title$)

 'Set up variables and check for errors:
  IF ActiveWin > 0 THEN : TempWin = ActiveWin: Set.ActiveWin 0
  IF WinDataBaseCount > 1 THEN
     FOR Count = 1 TO WinDataBaseCount
        IF Win(Count).Status = False THEN
           WinCount = Count
           FreeWindowSocketFound = True
           EXIT FOR
        END IF
     NEXT
     FreeWindowSocketFound = False
  END IF
  IF ObjectCount > 1 THEN
     FOR Count = 1 TO ObjectCount
        IF DataBase(Count).ControlType = 0 AND DataBase(Count).ControlID = 0 THEN
           ObjectCount = Count
           FreeObjectSocketFound = True
           EXIT FOR
        END IF
     NEXT
     FreeObjectSocketFound = False
  END IF
  IF FreeWindowSocketFound = False THEN
     WinDataBaseCount = WinDataBaseCount + 1
     WinCount = WinCount + 1
     REDIM PRESERVE Win(WinCount) AS WindowVariables
     REDIM PRESERVE WinTitle(WinCount) AS STRING
  END IF
  IF FreeObjectSocketFound = False THEN
     ObjectCount = ObjectCount + 1
     REDIM PRESERVE DataBase(ObjectCount)  AS databaseVariables
     REDIM PRESERVE WinOrder(WinCount)
  END IF

  New.Window = ObjectCount
 'expand databases:
  
 'write window data into databases
  DataBase(ObjectCount).ControlType = Wind
  DataBase(ObjectCount).ControlID = WinCount
  WinOrder(WinCount) = WinCount
  WinTitle(WinCount) = Title$
  Win(WinCount).Xpos = Xpos
  Win(WinCount).Ypos = Ypos
  Win(WinCount).XSize = XSize
  Win(WinCount).YSize = YSize
  Win(WinCount).Order = WinCount
  Win(WinCount).DataBaseEntry = ObjectCount
  Win(WinCount).Status = True

 'Create EMS window
  Win(WinCount).WindowContents = AllExpMem(SizeOf(XSize, YSize))
  CALL DefineEMSBufferSize(Win(WinCount).WindowContents, XSize, YSize, WinCount)
  
 'Draw window body:
  IF InterFace = Windows95 THEN Draw.Window95 WinCount, 1
  IF InterFace = WindowsXP THEN Draw.WindowXP WinCount, 1
  
  IF TempWin > 0 THEN Set.ActiveWin TempWin

END FUNCTION

FUNCTION On.Target (Xpos, Ypos, X1pos, Y1pos)
IF MouseX > Xpos THEN
   IF MouseY > Ypos THEN
      IF MouseX < X1pos THEN
         IF MouseY < Y1pos THEN
            On.Target = True
            EXIT FUNCTION
         END IF
      END IF
   END IF
END IF
On.Target = False
END FUNCTION

SUB Refresh.Windows
   SwichPage
      FOR Check = 1 TO WinCount
            WinID = WinOrder(Check)
            Future.EMSPut Win(WinID).Xpos, Win(WinID).Ypos, Win(WinID).WindowContents
      NEXT Check
   viewPage ActivePage
END SUB

SUB ReFreshScreen (ToWindow)
SwichPage
   Future.EMSPut 0, 0, BackGround
   IF WinCount > 0 THEN
      RefreshWindows 1, ToWindow
   END IF
viewPage ActivePage
END SUB

SUB RefreshWindows (FromWindow, ToWindow)
FOR Count = FromWindow TO ToWindow
    WinID = WinOrder(Count)
    Xpos = Win(WinID).Xpos
    Ypos = Win(WinID).Ypos
    Future.EMSPut Xpos, Ypos, Win(WinID).WindowContents
NEXT Count
END SUB

SUB Run.Gui
MouseChanged = False
IF Done = -3 THEN Done = -2: EXIT SUB
Done = False

IF TIMER - FrameCount! < (1 / ShowFramesPerSecond) THEN EXIT SUB
Future.UpdateMouse

'Update Mouse and Kayboard
OldMouseX = MouseX: OldMouseY = MouseY
MouseX = Future.MouseX: MouseY = Future.MouseY
MouseL = (Future.MouseB AND 1) = 1: MouseR = (Future.MouseB AND 2) = 2
Key$ = INKEY$

'ReFresh screen if neccecery
IF NeedToReDraw = True THEN
   NeedToReDraw = False
   ReFreshScreen WinCount
   ReFreshScreen WinCount
END IF

'Check if mouse position is changed and check on wich window Mouse
'cursor is located
IF MouseX <> OldMouseX OR MouseY <> OldMouseY THEN
   MouseChanged = True
   OnWindow = Get.ActiveWin
END IF

IF OnWindow > 0 OR ClButton > 0 AND InProcess = 0 THEN
   IF ClButton > 0 AND OnWindow <> PrWin THEN
      CheckWin = PrWin
   ELSE
      CheckWin = OnWindow
   END IF
   PrWin = CheckWin
   IF InterFace = WindowsXP THEN
      X1pos = Win(CheckWin).XSize - 29
      Ypos = -Border - Head + 2
      SetMaskColor 0
  ELSE
     X1pos = Win(CheckWin).XSize - 22
      Ypos = 1 - Border - Head + 2
   END IF
      ClButton = Get.ObjectValue(CloseButton, X1pos, Ypos, Win(CheckWin).DataBaseEntry, "", 0, ClButton)
   SetMaskColor -1
   IF ClButton > 0 THEN Done = True
END IF


'If mouse left button is pressed then check what to do
IF MouseL = True AND InProcess = 0 THEN
   IF OnWindow > 0 THEN
      SELECT CASE ActiveWin
         CASE OnWindow
            Xpos = Win(ActiveWin).Xpos + Border
            Ypos = Win(ActiveWin).Ypos + Border
            X1pos = Win(ActiveWin).XSize + Win(ActiveWin).Xpos - Border
            Y1pos = Win(ActiveWin).Ypos + Border + Head
            IF On.Target(Xpos, Ypos, X1pos, Y1pos) = True AND Done = False THEN
               InProcess = 1
               ProcessID = ActiveWin
               Temp3 = Win(ProcessID).Xpos
               Temp4 = Win(ProcessID).Ypos
               Temp1 = MouseX - Temp3
               Temp2 = MouseY - Temp4
               OldX1 = Temp3 + Win(ProcessID).XSize
               OldY1 = Temp4 + Win(ProcessID).YSize
               SwichPage
                  Future.EMSPutx Temp3, Temp4, BackGround, Temp3, Temp4, OldX1, OldY1
                  RefreshWindows 1, WinCount - 1
               SwichPage
               Done = True
            END IF
            CASE ELSE
            Done = True
            Set.ActiveWin OnWindow
      END SELECT
   END IF
      IF OnWindow = 0 AND ActiveWin > 0 THEN Set.ActiveWin 0: Done = True
END IF

IF InProcess = 1 THEN
   Done = True
   OldX = Temp3
   OldY = Temp4
   OldX1 = OldX + Win(ProcessID).XSize
   OldY1 = OldY + Win(ProcessID).YSize
   Temp3 = Win(ProcessID).Xpos
   Temp4 = Win(ProcessID).Ypos
   Win(ProcessID).Xpos = MouseX - Temp1
   Win(ProcessID).Ypos = MouseY - Temp2
   IF MouseL = True THEN
      SwichPage
         Future.EMSPutx OldX, OldY, BackGround, OldX, OldY, OldX1, OldY1
         RefreshWindows 1, WinCount
      viewPage ActivePage
   ELSE
      ReFreshScreen WinCount
      ReFreshScreen WinCount
      InProcess = 0
      ProcessID = 0
   END IF
   EXIT SUB
END IF
IF InProcess = 0 THEN
   Refresh.Windows
END IF
FrameCount! = TIMER
END SUB

SUB SaveBMP (X1%, Y1%, x2%, y2%, FileName$)
'saves part of the screen to bmp

XSize% = ABS(x2% - X1%) + 1
YSize% = ABS(y2% - Y1%) + 1

handle% = AllExpMem(SizeOf(XSize%, YSize%))

DefineEMSBufferSize handle%, XSize% - 1, YSize% - 1, EMSPageCount + 1
Future.EMSGet X1%, Y1%, x2%, y2%, handle%

Future.SNAPSHOT FileName$

DeAllEXPMem handle%

SetPage 0

END SUB

SUB Set.ActiveWin (WinID)
IF ActiveWin > 0 THEN
   IF InterFace = Windows95 THEN Draw.Window95 ActiveWin, 2
   IF InterFace = WindowsXP THEN Draw.WindowXP ActiveWin, 2
   OldActiveWin = ActiveWin
   ActiveWin = 0
END IF

IF WinID = 0 AND OldActiveWin > 0 THEN
   Future.EMSPut Win(OldActiveWin).Xpos, Win(OldActiveWin).Ypos, Win(OldActiveWin).WindowContents
   OldActiveWin = 0
   EXIT SUB
END IF

IF WinID > 0 THEN
   Order = Win(WinID).Order
   IF Order < WinCount THEN
      FOR Count = Order TO WinCount - 1
         SWAP Win(WinOrder(Count)).Order, Win(WinOrder(Count + 1)).Order
         SWAP WinOrder(Count), WinOrder(Count + 1)
      NEXT
   END IF
   WinOrder(WinCount) = WinID
   Win(WinID).Order = WinCount
   ActiveWin = WinID
   IF InterFace = Windows95 THEN Draw.Window95 ActiveWin, 3
   IF InterFace = WindowsXP THEN Draw.WindowXP ActiveWin, 3
END IF
Refresh.Windows
END SUB

SUB SwichPage
ActivePage = (ActivePage + 1) MOD 2
SetPage ActivePage
END SUB

